#include <iostream>
#include <vector>

#include <arc/ldapquery.h>

void callback(const std::string& attr, const std::string& value, void *ref) {

	std::cout << "Callback : Attr: " << attr << "Value: " << value << std::endl;
}

int main() {

	try {
		std::string filter = "(objectclass=*)";
		// Giis test
		LdapQuery giis_ldap = LdapQuery("grid.nbi.dk", 2135, true, "", 10);
		std::vector <std::string> giis_attrs;
		giis_attrs.push_back("giisregistrationstatus");
		giis_ldap.Query("Mds-Vo-Name=NorduGrid,O=Grid", filter, giis_attrs,
		                LdapQuery::base);
		giis_ldap.Result(callback, NULL);

		// Cluster test
		LdapQuery cluster_ldap = LdapQuery("benedict.aau.dk", 2135, true, "", 10);
		std::vector <std::string> cluster_attrs;
		cluster_ldap.Query("mds-vo-name=local,o=grid", filter, cluster_attrs,
		                   LdapQuery::subtree);
		cluster_ldap.Result(callback, NULL);
	}
	catch (LdapQueryError e) {
		std::cerr << "Caught exception: " <<  e.what() << std::endl;
	}
	catch (std::exception e) {
		std::cerr << "Hmm.." << e.what() << std::endl;
	}

	return 0;
}
