#include <iostream>

#include <arc/stringconv.h>

using namespace std;

int main() {

	try {
		string s("123");
		cout << "Converting string to integer: " << s << endl;
		cout << "Result: " << stringtoi(s) << endl;
	}
	catch (StringConvError e) {
		cout << e.what() << endl;
	}

	try {
		string s("0x123");
		cout << "Converting string to integer: " << s << endl;
		cout << "Result: " << stringtoi(s) << endl;
	}
	catch (StringConvError e) {
		cout << e.what() << endl;
	}

	try {
		string s("0123");
		cout << "Converting string to integer: " << s << endl;
		cout << "Result: " << stringtoi(s) << endl;
	}
	catch (StringConvError e) {
		cout << e.what() << endl;
	}

	try {
		string s("123.45");
		cout << "Converting string to integer: " << s << endl;
		cout << "Result: " << stringtoi(s) << endl;
	}
	catch (StringConvError e) {
		cout << e.what() << endl;
	}

	try {
		string s("12A");
		cout << "Converting string to integer: " << s << endl;
		cout << "Result: " << stringtoi(s) << endl;
	}
	catch (StringConvError e) {
		cout << e.what() << endl;
	}

	try {
		string s("0x12A");
		cout << "Converting string to integer: " << s << endl;
		cout << "Result: " << stringtoi(s) << endl;
	}
	catch (StringConvError e) {
		cout << e.what() << endl;
	}

	try {
		string s("");
		cout << "Converting string to integer: " << s << endl;
		cout << "Result: " << stringtoi(s) << endl;
	}
	catch (StringConvError e) {
		cout << e.what() << endl;
	}

	try {
		string s("123");
		cout << "Converting string to float: " << s << endl;
		cout << "Result: " << stringtof(s) << endl;
	}
	catch (StringConvError e) {
		cout << e.what() << endl;
	}

	try {
		string s("123.45");
		cout << "Converting string to float: " << s << endl;
		cout << "Result: " << stringtof(s) << endl;
	}
	catch (StringConvError e) {
		cout << e.what() << endl;
	}

	try {
		string s("0x123.45");
		cout << "Converting string to float: " << s << endl;
		cout << "Result: " << stringtof(s) << endl;
	}
	catch (StringConvError e) {
		cout << e.what() << endl;
	}

	try {
		string s("123.45e2");
		cout << "Converting string to float: " << s << endl;
		cout << "Result: " << stringtof(s) << endl;
	}
	catch (StringConvError e) {
		cout << e.what() << endl;
	}

	try {
		string s("123.45e-2");
		cout << "Converting string to float: " << s << endl;
		cout << "Result: " << stringtof(s) << endl;
	}
	catch (StringConvError e) {
		cout << e.what() << endl;
	}

	try {
		string s("12 Baker Street");
		cout << "Converting string to float: " << s << endl;
		cout << "Result: " << stringtof(s) << endl;
	}
	catch (StringConvError e) {
		cout << e.what() << endl;
	}
}
