#ifndef TEST_CONFIG_CACHE_H_
#define TEST_CONFIG_CACHE_H_

#include "../config_cache.h"
#include "../../misc/log_time.h"

#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/extensions/TestFactoryRegistry.h>
#include <cppunit/ui/text/TestRunner.h>
#include <list>
#include <utime.h>

class ConfigCacheTest : public CPPUNIT_NS::TestFixture { 

  CPPUNIT_TEST_SUITE (ConfigCacheTest);
  CPPUNIT_TEST (testOneCache);
  CPPUNIT_TEST (testTwoCaches);
  CPPUNIT_TEST (testSubstitutionCaches);
  CPPUNIT_TEST (testSubstitutionCachesNoUser);
  CPPUNIT_TEST (testUsers);
  CPPUNIT_TEST (testConstructorExceptions);
  CPPUNIT_TEST_SUITE_END ();

private:
  char _tmpfile[40];
  int _h;
  CacheConfig * _cache_config;
  
public: 
  void setUp();
  void tearDown();
  
protected:
  void testOneCache();
  void testTwoCaches();
  void testSubstitutionCaches();
  void testSubstitutionCachesNoUser();
  void testUsers();
  void testConstructorExceptions();

};


#endif /*TEST_CONFIG_CACHE_H_*/
