#include "client.h"

#include "service.h"

// Interface to remote registered service
FlOServiceRemote::FlOServiceRemote(const std::string& url,const std::string& id):url_(url),id_(id) {
  //acceptsCreatedOrdinary = true;
  //acceptsCreatedReference = true;
  //acceptsUpdatedOrdinary = true;
  //acceptsUpdatedReference = true;
  //acceptsDeletedOrdinary = true;
  //acceptsDeletedReference = true;
}

FlOServiceRemote::~FlOServiceRemote(void) {

}

void FlOServiceRemote::notify(const FlOMessage& m) {
  // Check if service wants to accept this message (TODO)

  msgs_lock_.block();
  {
    FlOMessage m_(m);
    std::string s; m_.serialize(s);
    odlog(3)<<"FlOServiceRemote: notify: "<<url_<<endl;
    odlog(3)<<"FlOServiceRemote: notify: "<<s<<endl;
  };
  for(list<FlOMessage>::iterator i=msgs_.begin();i!=msgs_.end();++i) {
    if((*i) == m.object()) {
      (*i)=m.type(); msgs_lock_.unblock(); return;
    };
  };
  msgs_.push_back(m);
  msgs_lock_.unblock();
}

void FlOServiceRemote::registr(FlOService& s) {
  regs_lock_.block();
  for(list<FlORegistration>::iterator i=regs_.begin();i!=regs_.end();++i) {
    if(&(i->service()) == &s) {
      regs_lock_.unblock(); return;
    };
  };
  regs_.push_back(s);
  regs_lock_.unblock();
}

void FlOServiceRemote::maintain(void) {
  odlog(3)<<"FlOServiceRemote: maintain"<<endl;
  // This is only function which actually sends requests over network
  FlOClient c(*this);
  if(!c) return;
  // Send registrations
  regs_lock_.block();
  for(std::list<FlORegistration>::iterator i = regs_.begin();i!=regs_.end();) {
    odlog(3)<<"FlOServiceRemote: maintain: registration"<<endl;
    regs_lock_.unblock();
    if(c.connect() != 0) return;
    if(c.registr(i->service())) {
      regs_lock_.block();
      i=regs_.erase(i);
    } else {
      regs_lock_.block();
      ++i;
    };
  };
  // Send notifications
  int n = msgs_.size();
  if(c.connect() != 0) return;
  if(!c.notify(msgs_)) return;
  msgs_lock_.block();
  for(;n>0;n--) msgs_.erase(msgs_.begin());
  msgs_lock_.unblock();
}
